<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Guess 7 Train Game</title>
  </head>
  <body>
    <input type="number" id="guess-input" min="1" max="7">
    <input type="button" id="enter-guess" value="Guess">
    <pre id="main-content"></pre>
    <script>
        /** Think of this variable as an imaginary train pulling 7 cars
         *  Each car holds a number from 1-7
         */
        let train = [1,2,3,4,5,6,7];

        /** Think of this variable as an imaginary checklist representing a check
         *  against each imaginary train car. All are false initially signifying
         *  no checks have been made yet
         */
        let trainCheckList = [false, false, false, false, false, false, false];

        /** Think of this variable as holding the truth of if the game is over or not */
        let gameOver = false;

        /** Think of this variable as holding the car position of the 7 once found */
        let winningCar = null;

        /** Found this algorithm function from an internet search, I named it something
         *  meaningful to me, it accepts an array as parameter, randomizes the positions of
         *  the numbers within (they start out ordered 1-7)
         */
        function shuffleTrainCars(arrayToShuffle){
            for (var i = arrayToShuffle.length - 1; i > 0; i--) {
                var j = Math.floor(Math.random() * (i + 1));
                var temp = arrayToShuffle[i];
                arrayToShuffle[i] = arrayToShuffle[j];
                arrayToShuffle[j] = temp;
            }
        }

        /** This function is given a car position parameter and accesses the value
         *  at that position, performing comparison logic to check for 7(game over)
         *  or not, updating checklist and if 7 is found updating gameover
         *  and winning car position variables
        */
        function checkCar(carPosition){

            let foundSeven = false;

            if(trainCheckList[carPosition] == true){
                //you already checked this spot
                return false;
            } else {
                if(train[carPosition] == 7){
                    foundSeven = true;
                    trainCheckList[carPosition] = true;
                    winningCar = carPosition + 1;
                    gameOver = true;
                } else {
                    trainCheckList[carPosition] = true;
                }
            }
            return foundSeven;
        }

        /** This function updates the contents of our main UI element
         *  by iterating over each train while also checking our checklist
         *  if the train car has not been checked, it renders a '?', if it has
         *  been checked, it shows the number at that car position (index)
        */
        function updateUI(){
            let mainContentDiv = document.getElementById('main-content');
            let displayTextStart = 'train = [ ';
            
            
            train.forEach((carReference, carSlotInArray) => {
                if (trainCheckList[carSlotInArray] == false){
                    displayTextStart += '?, '
                } else {
                    displayTextStart += train[carSlotInArray] + ', ';
                }              

            });
            let displayTextGameOver = '';
            if(gameOver){
                //                                                                                   \n is a special 'newline' character
                displayTextGameOver = ' You won! 7 was hiding in car ' + winningCar + ' GAME OVER :) \n';
                //syntax for creating object inline
                let JSONObjectSummary = { trainArray: train, checksArray: trainCheckList, gameOver: gameOver, winningCar: winningCar };
                //built-in JSON library can convert object into a string (for display);
                displayTextGameOver += '\nJSON Summary:\n' + JSON.stringify(JSONObjectSummary);
            }
            let displayTextEnd = ' ]';
            //sets content of HTML element to the combined total of string variables
            mainContentDiv.innerHTML = displayTextStart + displayTextEnd + displayTextGameOver;
        }

        /** This function uses built-in library to get a javascript variable refernce
         *  to an HTML element by its unique id. It also uses a built in event library
         *  for detecting a click, and doing logic after
        */
        function setupInputListener(){
            let guessPositionInput = document.getElementById('guess-input');
            let enterGuessButton = document.getElementById('enter-guess');

            enterGuessButton.addEventListener('click', (event) => {
                //this logic runs each time you click guess button element
                checkCar(guessPositionInput.value - 1);
                updateUI();
            }) 
        }

        /** fire our function to setup input handling*/
        setupInputListener();

        /** fire our function to shuffle train cars randomly*/
        shuffleTrainCars(train);

        /** fire our function to render UI on first load*/
        updateUI();

    </script>

  </body>

</html>
